var crypto = require('crypto');

/* The SessionsDAO to be constructed with a connected database object */
function SessionsDAO(db) {
    "use strict";

    if (false === (this instanceof SessionsDAO)) {
        console.log('SessionsDAO constructor called without "new" operator');
        return new SessionsDAO(db);
    }

    this.startSession = function(username, callback) {
        "use strict";

        // Generate session id
        var current_date = (new Date()).valueOf().toString();
        var random = Math.random().toString();
        var session_id = crypto.createHash('sha1').update(current_date + random).digest('hex');

        // Create session document
	
        var session = {'username': username, '_id': session_id,'type':'session'}
	// Insert session document
	console.log('session start');
  	db.save(session_id, session, function (err, res) {
		console.log('session start.1'+res);
		console.log(err);

      	      if (err) {
		  // Handle error
		  res += ' SAVE ERROR: Could not save record!!\n';
	      } else {
		  // Handle success
		  res += ' SUCESSFUL SAVE\n';
	      }
	      console.log('session start.2'+res);
	      callback(err, session_id);

	   });


    }

    this.endSession = function(session_id, callback) {
        "use strict";
        // Remove session document
        callback();
    }

    this.getUsername = function(session_id, callback) {
        "use strict";

        if (!session_id) {
            callback(Error("Session not set"), null);
            return;
        }

	db.view('session/bySessionid', { key: session_id }, function (err, doc) {
      		console.dir(doc);
            "use strict";

            if (err) return callback(err, null);

            if (!doc) {
                callback(new Error("Session: " + doc + " does not exist"), null);
                return;
            }

            callback(null, doc[0].value.username);

	});

    }
}

module.exports.SessionsDAO = SessionsDAO;
